PL/php - Bug #4972

array PHP <-> Pg conversion is broken
Description
Element parsing in arrays can easily be confused. Test case:

create or replace function another_text_test (text[], int)

returns text language plphp as $$ return S$Sargsr0[$Sargsrl]; $$;

Strings should be quoted before passing them to PHP, so the NOTICE from PHP here is bogus:

pl_regression=# select another_text_test ($${"foo", 'bar', "{"}$S,

NOTICE: plphp: Use of undefined constant foo - assumed 'foo'

another_text_test

foo
(1 fila)

The same reason causes this to "eat" the inner level of quotes:

pl_regression=# select another_text_test ($${"'bar'", "{"}sS,
another_text_test

bar

(1 fila)

Note particularly this totally unexpected behavior:

pl_regression=# select another_text_test ($${"'bar'", "{"}sS,
another_text_test

array (

(1 fila)

0);

1);

0);

History

#1 - 01/16/2008 08:16 AM - Alvaro Herrera

- Status changed from New to In Progress

#2 - 03/12/2010 08:38 AM - Alvaro Herrera

- Assignee deleted (Alvaro Herrera)

#3 - 05/21/2011 04:50 PM - Alvaro Herrera

- Priority changed from Low to Normal
